/*  $Id: a.out-linux.hh,v 1.4 1999/06/20 01:27:11 shaggy Exp $
 *      relative path: ./lib/bff/a.out-linux
 */ 

#ifndef ASM

#include <vstream>
#include <vdir>


// Note:  This will eventually be derived from a common object
// for loading binary object files of different formats
// and for testing the types of files

// Also note:  a.out support, in this format, is nearly non-existent
// right now.  This is being provided for now so that the SOLO
// bootloader can recognize the a.out format (using the offsets 
// generated from this file), but this C++ class is currently unused.

class a_out_linux {
public:
	typedef unsigned char	uchar;
	typedef unsigned short	ushort;
	typedef unsigned long	ulong;

// main file header:

	struct exec {
  		ushort a_magic;		// magic number 
		ushort a_machtype;	// machine type 
		ulong a_text;		// size of text
		ulong a_data;		// size of data
		ulong a_bss;		// size of uninitialized data 
		ulong a_syms;		// size of symbol table
		ulong a_entry;		// initial execution address
		ulong a_trsize;		// size of text relocation info
		ulong a_drsize;		// size of data relocation info
	};

	enum a_magic {
		OMAGIC = 0407,		// object file or impure executable
		NMAGIC = 0410,		// pure executable
		ZMAGIC = 0413,		// demand-paged executable
		QMAGIC = 0314,		// like ZMAGIC, with header in text
		CMAGIC = 0421,		// core file
		LMAGIC = 0430		// library file 
	};

	enum a_machtype {
		M_8086 = 4,
		M_386 = 100
	};

// symbol/relocation table:

	struct nlist {
		ulong	n_strx;
		uchar	n_type;
		char 	n_other;
		ushort 	n_desc;
		ulong 	n_value;
	};

	enum n_type {
		N_UNDF = 0,
		N_ABS = 2,
		N_TEXT = 4,
		N_DATA = 6,
		N_BSS = 8,
		N_COMM = 0x12,	// common - ld internal
		N_LABEL = 0x14,	// label - ld internal
		
		N_TYPE = 0x1e,	// type mask
		N_EXT = 1,
		N_FN = 0x1f,	// file name symbol

		N_SHARE = 0x20,	// global sym -- register in /lib
		N_STAB = 0xe0,	// if any bits set, an SDB entry 
		N_INDR = 0xa,	// indirect reference immediately follows
		N_SETA = 0x14,
		N_SETT = 0x16,
		N_SETD = 0x18,
		N_SETB = 0x1a,
		N_SETV = 0x1c
	};

	struct relocation_info {
		ulong	r_address;
		unsigned r_symbolnum:24;
		unsigned r_pcrel:1;
		unsigned r_length:2;
		unsigned r_extern:1;
		unsigned r_pad:4;
	};

private:
	exec hdr;
	vstream *stream;	// current file
public:
	a_out_linux(vstream *stream);
	~a_out_linux();
};


#else

#include "a.out-linux.ofs"
#include <endian.h>

#endif 


