/*  $Id: Perror.h,v 1.3 1999/06/20 01:27:16 shaggy Exp $
 *      relative path: ./lib/bff/elf32
 */

#include <string.h>
#include <errno.h>

#include "Error.h"

class Perror : public Error {
	union {
		const char *str;
		int num;
	};
	bool numeric;
public:
	Perror(const char *s = 0) : Error(strerror(errno))
		{ str = s; numeric = false; }
	Perror(int n) : Error(strerror(errno))
		{ num = n; numeric = true; }
	char* msg(char *buf) const;
};


#define SYSCALL(f)		if(f < 0) THROW(Perror())
#define SYSCALL_str(f,s)	if(f < 0) THROW(Perror(s))
#define SYSCALL_num(f,n)	if(f < 0) THROW(Perror(n))

