/*  $Id: cpuinfo.h,v 1.10 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/boot/m-pc
 */ 

#include <btypes.h>


/* CPU family: */
#define CPU_8086	0
#define CPU_80186	1
#define CPU_80286	2
#define CPU_80386	3
#define CPU_80486	4
#define CPU_80586	5
#define CPU_PENTIUM	5
#define CPU_80686	6
#define CPU_PENTIUM_PRO	6
#define CPU_80786	7
#define CPU_SEPTIUM	7
#define	CPU_UNKNOWN	0xff

#define CPU_MODEL_UNKNOWN	0xff
#define CPU_REVISION_UNKNOWN	0xff
#define CPU_TYPE_UNKNOWN	0xff

/* CPU flags: */
#define CPU_HAS_FPU		0x0001
#define CPU_HAS_MCHECK		0x0080
#define CPU_HAS_CMPXCHG8B	0x0100


#ifndef ASM

struct CpuInfo {
	_uint32	magic;	/* "In86" */
	_uint8	family;
	_uint8	model;
	_uint8	revision;
	_uint8	type;
	_uint32	flags;
	char	vendor[12];
	_uint8	null;	/* to terminate 'vendor' */
	_uint8	resv1;
	_uint8	resv2;
	_uint8	resv3;
	const char *name;
};

#endif


/* Notes:
 *	The "magic" number is used to identify the type of CPU structure
 *	being used, and thus also the general type of the CPU.
 *	This is 4 byte value, composed of printable ascii characters.
 *	In86 is being used for Intel 80x86 processors, and the following
 *	names could potentially be used for other processors:
 *		In86		Intel 80x86 series
 *		InI8		Intel i860 
 *		RS6K		R6000 series
 *		Mo68		Motorola 680x0 series
 *		Mo88		Motorola 88000 series
 *		NS32		National Semiconductor 32000 series
 *		PWPC		Power PC
 *		Alph		DEC Alpha
 *		MIPS		MIPS processor
 *		Clip		Clipper processor
 *		SPRC		SPARC series
 *		6502		:)
 */

