/*  $Id: solo_bp.cc,v 1.6 1999/06/20 01:27:21 shaggy Exp $
 *      I/O library functions for interfacing with SOLO
 */     

#include <defines>
#include <boot/bootparam.h>

#include "libsolo.h"


static int solo_map_refcount = 1;

static void* (*solo_call_MapBootParam)(void *) = 0;
static void* (*solo_call_UnmapBootParam)(void *) = 0;

static void *bootparam_mapping;


void*
solo_MapBootParam()
{
	if(!solo_map_refcount++)
		return solo_call_MapBootParam(bootparam_mapping);
	else
		return 0;
}

void
solo_UnmapBootParam(void *savemap)
{
	if(!--solo_map_refcount)
		bootparam_mapping = solo_call_UnmapBootParam(savemap);
}


void
solo_set_MapBootParam(void* (*f)(void *))
{
	solo_call_MapBootParam = f;	
}


void
solo_set_UnmapBootParam(void* (*f)(void *))
{
	solo_call_UnmapBootParam = f;	
}

