/*  $Id: solo_lseek.cc,v 1.8 1999/07/16 20:18:48 shaggy Exp $
 *      I/O library functions for interfacing with SOLO
 *      relative path: ./lib/boot/m-pc
 */

#include <defines>
#include <boot/bootparam.h>
#include <boot/fileinfo.h>

#include "libsolo.h"


_off_t
solo_lseek(solo_fd_t fd, _off_t ofs, int whence)
{
	FileInfo info;
	BootParamPtr bootparam;

	switch(whence) {
	case SOLO_SEEK_CUR:
		ofs += bootparam->tell(fd);
		break;
	case SOLO_SEEK_END:
		bootparam->fstat((BootParam::fd_t)fd, &info);
		ofs += info.size;
		break;
	case SOLO_SEEK_SET:
	default:
		break;
	}
	bootparam->seek(fd, ofs);
	return bootparam->tell(fd);
}

