/*  $Id: vthread.hh,v 1.4 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/c++
 */

#ifndef __vthread_hh__
#define __vthread_hh__

class vdir;
class vtask;
class vstream;

class vthread {
public:
	virtual ~vthread() {}
	virtual vtask* get_task() const;
	virtual const vdir* get_root() const;
	virtual const vdir* get_cwd() const;
	virtual vstream* get_stdin() const;
	virtual vstream* get_stdout() const;
	virtual vstream* get_stderr() const;
	virtual bool set_root(const vdir *dir);
	virtual bool set_cwd(const vdir *dir);
	virtual bool set_stdin(vstream *stream);
	virtual bool set_stdout(vstream *stream);
	virtual bool set_stderr(vstream *stream);
	virtual vthread* dup() const;
};


extern vthread *thread;



// for simplicity, we could do something like:
// #define STDIN (*(thread->get_stdin()))
// #define STDOUT (*(thread->get_stdout()))
// etc..

#endif
