/*  $Id: string.cc,v 1.11 2000/01/12 03:44:45 shaggy Exp $
 *      string manipulation functions
 *      relative path: lib/posix
 *  
 *  Copyright (c) 1994 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/members/shaggy
 */

#include <stdx1.h>
#include "stddef.h"
#include "string.h"

sz*
strchr(register csz *s, int c)
{
	while(*s && (*s != c))
		s++;
 	if(*s == c)
		return (sz*)s;	/* this cast seems like a bad idea... */ 
	return nil;
}

sz*
strrchr(register csz *s, int c)
{
	sz *cp = nil;
	while(*s) {
		if(*s == c)
			cp = (sz*)s;	/* this one too... */
		s++;
	}
	return cp;
}

size_t
strlen(register csz *s)
{
	register int n = 0;
	while(*s++)
		n++;
	return n;
}

sz*
strcpy(sz *s1, register csz *s2)
{
	register sz *sp1 = s1;
	while(*s2)
		*sp1++ = *s2++;
	*sp1 = '\0';
	return s1;
}

sz*
strncpy(sz *s1, register csz *s2, size_t n)
{
	register sz *sp1 = s1;
	while(*s2 && n--)
		*sp1++ = *s2++;
	if (n)
		*sp1 = '\0';
	return s1;
}

int
strcmp(register csz *s1, register csz *s2)
{
	register int dif;
	while(*s1)
		if ((dif = (*s1++ - *s2++)))
	return dif;
	return *s1 - *s2;
}

int
strncmp(register csz *s1, register csz *s2, size_t n)
{
	register int dif;
	while(*s1 && n-- > 1)
		if ((dif = (*s1++ - *s2++)))
	return dif;
	return *s1 - *s2;
}

sz*
strcat(sz *s1, register csz *s2)
{
	register sz *sp1 = s1;
	while(*sp1)
		sp1++;
	while(*s2)
		*sp1++ = *s2++;
	*sp1 = '\0';
	return s1;
}

sz*
strncat(sz *s1, register csz *s2, size_t n)
{
	register sz *sp1 = s1;
	while(*sp1)
		sp1++;
	while(*s2 && n--)
		*sp1++ = *s2++;
	*sp1 = '\0';
	return s1;
}

