/*  $Id: bios.h,v 1.6 1999/06/22 23:47:04 shaggy Exp $
 *      various definitions for BIOS memory and function access
 */

#define BIOS_SEG		0x40	// BIOS data segment
#define BIOS_DATA		0x400	// absolute start

#define BIOS_KEY_NEXT		0x41a	// next char in buf
#define BIOS_KEY_AVAIL		0x41c	// end of buf + 1
#define BIOS_KEY_BUF		0x41e	// keyboard buffer
#define BIOS_KEY_BUFEND		0x43e	// one past end

#define BIOS_VID_MODE		0x449	// current video mode
#define BIOS_VID_WID		0x44a	// screen width
#define BIOS_VID_HGT		0x484	// screen height-1
#define BIOS_VID_LENGTH		0x44c	// length of display page
#define BIOS_VID_X		0x450	// current column
#define BIOS_VID_Y		0x451	// current row
#define BIOS_VID_CURSTART	0x460	// cursor start
#define BIOS_VID_CUREND		0x461	// cursor end
#define BIOS_VID_PAGE		0x462	// current page
#define BIOS_VID_CRTC		0x463	// CRTC I/O Port
#define BIOS_VID_CURMODE	0x465	// current mode
#define BIOS_VID_CURCOLOR	0x466	// current color
#define BIOS_VID_BPCHAR		0x485	// bytes per character

#define BIOS_RESET_VEC		0x467	// reset vector
#define BIOS_RESET_FLAG		0x472	// reset flag
#define BIOS_RESET_FLAG_SAVE	0x4321	// preserve memory
#define BIOS_RESET_FLAG_WARM	0x1234	// warm boot
#define BIOS_RESET_FLAG_COLD	0x0000	// cold boot
#define BIOS_RESET_FLAG_BURN	0x0064	// burn-in mode

