/*  $Id: device.h,v 1.6 1999/06/20 17:10:36 shaggy Exp $
 *      relative path: ./sys/boot/m-pc
 */ 

#define DEV_NULL	0x00	 

#define DEV_MEM		0x01	// physical memory (real mode)
#define DEV_VMEM	0x02	// virtual memory (protected mode)

#define DEV_PORT	0x03	// I/O ports
// for unit number, 0=read separate ports,
//		   x=keep re-reading sequence of 'x' ports 
// for flags, port size = 2^flag
//	(i.e. 0=byte ports, 1=word ports, 2=long ports, etc)
// the effective blocksize = (2^flag)*unit   if unit>0
//			or   (2^flag)	     otherwise

#define DEV_CONSOLE	0x04	// console
// for flag bits:
#define  CONSOLE_CANON	0x01	// canonical (line editing)
#define  CONSOLE_ECHO	0x02	// echo input

#define DEV_DISK	0x05	// standard disk (floppy, hd)
// for unit:
#define	 DISK_FD0	0x00	// floppy disk 0 (A:)
#define	 DISK_FD1	0x01	// floppy disk 1 (B:)
#define  DISK_HD0	0x80	// hard drive 0 (primary/master)
#define  DISK_HD1	0x81	// hard drive 1 (secondary/slave)
// and for the flag bits,
// the high bit is set to 1 for linear disk I/O (block#)
// or 0 for nonlinear disk I/O (cylinder/sector/head),
#define  DISK_LINEAR 0x80
// and bits 6-0 select the partition number, where 0 is the whole disk,
// 1 through 4 are primary partitions, and 5 through 127
// are extended (logical) partitions...

#define DEV_MSG		0x06	// logging of kernel messages

// #define DEV_SERIAL	0x07	// serial ports
// #define DEV_PARALLEL	0x08	// parallel ports
// #define DEV_KEYBOARD	0x09	// keyboard
// #define DEV_VIDEO	0x0a	// video display
// #define DEV_SCSI	0x0b	// SCSI disks

#define NDEVICES	0x07	// number of devices


#define ERR_DISK	0x6564	// 'de'

