/*  $Id: vmem.h,v 1.5 1999/06/14 17:23:54 inferno Exp $
 *      segment and virtual memory definitions
 */

// Hardware-specific stuff:

#define PAGE_SIZE	4096		// 4K pages

#define MAXMEM_16BIT	0x000010000	// 16-bit segment size: 64K
#define MAXMEM_BASE	0x0000a0000	// base memory: 640K 
#define MAXMEM_REAL	0x000100000	// real-mode: 1 Megabyte
#define MAXMEM_DMA	0x001000000	// DMA: 16 Megabytes 


#define G_1BYTE 	0
#define G_4K		1
#define D_16BIT		0
#define D_32BIT		1
#define DPL_SYS		0
#define DPL_USER	3
#define S_SYSTEM	0
#define S_CODEDATA	1
#define P_PRESENT	1
#define P_NOTPRESENT	0
#define A_ACCESSED	1
#define A_NOTACCESSED	0
#define TYPE_DATA_RO	0x0
#define TYPE_DATA_RW	0x2
#define TYPE_DATA_RO_DN	0x4
#define TYPE_DATA_RW_DN	0x6
#define TYPE_EXEC_NR	0x8
#define TYPE_EXEC_R	0xa
#define TYPE_EXEC_NRC	0xc
#define TYPE_EXEC_RC	0xe
#define TYPE_TSS	0x9

#ifdef ASM
#define SEG_DESC(base,limit,g,d,dpl,type) \
	.word	limit&0xffff, base&0xffff, \
		[[base>>16]&0xff]|[type<<8]|[S_CODEDATA<<12] \
			|[dpl<<13]|[P_PRESENT<<15], \
		[[limit>>16]&0xf]|[d<<6]|[g<<7] \
			|[[[base>>24]&0xff]<<8]
#define TSS_DESC(base,limit,dpl)  \
		SEG_DESC(base,limit,G_1BYTE,D_16BIT,dpl,TYPE_TSS)
#endif


// initial segment layout for SOLO...

#define SEG_NULL	0x00	// the null descriptor
#define SEG_DS32	0x08	// DS segment to use in 32-bit mode
#define SEG_CS32	0x10	// CS segment to use in 32-bit mode
#define SEG_DS16	0x18	// DS segment to use in 16-bit mode
#define SEG_CS16	0x20	// CS segment to use in 16-bit mode 
#define SEG_TSS		0x28	// segment for task switches

// CR0 values:

#define CR0_PG		0x80000000
#define CR0_PE		0x00000001

